function  [] = Main
% Version 1.2
% Last Modified: May 24th, 2009
% Ali Tawfiq
% Multimedia Labratory, The Edward S. Rogers Sr. Dept of Electrical and
% Computer Engineering, University of Toronto

%**************************************************************************
%A simple communication system is created by feeding a randomly generated
%stream of data [Or if user wishes they can feed in their own data, refer 
%to 'CreateSig.m'] into a specific modulator, adding noise and trying to 
%retrieve the original signal. Returns the Bit Error rate and a semilog of
%SNR Vs BER. 
%       
%   How to start the simulation:
%       [] = Main
%             - The user must use the function "CreateSig" to set the input
%             parameters to the communication system. 
%**************************************************************************


%% ================== Create Signal ======================
%%========================================================
% This function is called to set the paramenters, create a random input
% signal, and converts to symboles. 
Fout_sig = CreateSig;

%% ================== Mapping ============================
%%========================================================
Fout_sig = Mapping (Fout_sig);

%% ================== Transmitter ========================
%%========================================================
Fout_sig = PulseShaping(Fout_sig);

for ii= 1: Fout_sig.itt

%% ============ Transmiter, Channel & Receiver ===========
%%========================================================
    Fout_tx = Transmit (ii, Fout_sig);
    Fout_ch = Channel (Fout_sig, Fout_tx);
    Fout_sig = Receiver (ii,Fout_sig, Fout_ch);
end

%% =================== Plotting ==========================
%%========================================================
Plotting (Fout_sig);

%% =================== Saving ============================
%%========================================================
if strcmp (Fout_sig.Saving, 'backup')
    Fout_sig.Out=Fout_sig.Out(2:end);
    S1= sprintf('./Output/Output of %s-%s (%d, %d)', Fout_sig.Mod,Fout_sig.FltrType, Fout_sig.L, Fout_sig.itt);
    save (S1, '-struct', 'Fout_sig', 'BER', 'InSig', 'Out','InSym');
end