function symbols = a16qam(bits)

d_array = signal_constellation('16QAM');
bit_matrix = reshape(bits,4,length(bits)/4);
hindex = zeros(1,length(bits)/4);
vindex = zeros(1,length(bits)/4);
greycode = [[0 0];[0 1];[1 1];[1 0]];
greycode = logical(greycode);
for v = 1 : 4
   mv = ((bit_matrix(1,:) == greycode(v,1)) & (bit_matrix(2,:) == greycode(v,2)));
   vindex(mv) = v;
end;
for h = 1 : 4
   mh = ((bit_matrix(3,:) == greycode(h,1)) & (bit_matrix(4,:) == greycode(h,2)));
   hindex(mh) = h;
end;
index = (vindex-1)*4 + hindex;
symbols = d_array(index);

%testbits = [[0 0 0 0],[0 0 0 1],[0 0 1 1],[0 0 1 0],...
%            [0 1 0 0],[0 1 0 1],[0 1 1 1],[0 1 1 0],...
%            [1 1 0 0],[1 1 0 1],[1 1 1 1],[1 1 1 0],...
%            [1 0 0 0],[1 0 0 1],[1 0 1 1],[1 0 1 0]];