function symbols = a64mrdpsk(bits)

N = 4;
M = 16;
ary = N * M;
grp_num = length(bits)/log2(ary);
d_array = signal_constellation('64MRDPSK');
amp = d_array(1:4);
p_ref = 0;
p_delta = 2*pi/16;
symbols = [];
for k = 1 : grp_num
   grp = bits((k-1)*log2(ary)+[1:log2(ary)]);
   ga = grp(1:log2(N));
   gp = grp(log2(N)+1:log2(ary));
   switch (strcat(num2str(ga(1)),num2str(ga(2))))
   case {'00'}
      sa = amp(1);
   case {'01'}
      sa = amp(2);
   case {'11'}
      sa = amp(3);
   case {'10'}
      sa = amp(4);
   otherwise
      error('*** A64MRDPSK.M : Unknown Amplitude! ***');
   end;
   switch (strcat(num2str(gp(1)),num2str(gp(2)),num2str(gp(3)),num2str(gp(4))))
   case {'0000'}
      sp = 0;
   case {'0001'}
      sp = 1;
   case {'0011'}
      sp = 2;
   case {'0010'}
      sp = 3;
   case {'0110'}
      sp = 4;
   case {'0111'}
      sp = 5;
   case {'0101'}
      sp = 6;
   case {'0100'}
      sp = 7;
   case {'1100'}
      sp = 8;
   case {'1101'}
      sp = 9;
   case {'1111'}
      sp = 10;
   case {'1110'}
      sp = 11;
   case {'1010'}
      sp = 12;
   case {'1011'}
      sp = 13;
   case {'1001'}
      sp = 14;
   case {'1000'}
      sp = 15;
   otherwise
      error('*** A64MRDPSK.M : Unknown Phase! ***');
   end;
   p_ref = mod(p_ref+sp,M);
   symbols = [symbols, sa*exp(j*p_ref*p_delta)];
end;