function [TrainBlock, DataBlock] = data_block(DataBlockType, L, length)
%Ali changed the input Amount to length
%Will change every 162 to 'length'

% '0 Symbol'
% '1 Symbol'
% '1/1 Symbols','2/2 Symbols','3/3 Symbols'
% '3x1 Symbols','3x2 Symbols'
% '4x1 Symbols'
% '1 Symbol End'
% '1/1 Symbols End','2/2 Symbols End','3/3 Symbols End'
% '3x1 Symbols End','3x2 Symbols End'
% '4x1 Symbols End'
% '8x1 Symbols','16x1 Symbols','14 Symbols','14/3/3/3/3 Symbols'

% TrainBlock[[Position of first training symbol in the group  Position of the last training symbol in the group] ; ... next group ...]
% DataBlock[[Position of first data symbol in the group  Position of the last data symbol in the group] ; ... next group ...]

if (nargin == 1)
    switch (DataBlockType)
    case {'0 Symbol'}
       TrainBlock = [0 0];
       DataBlock = [1 162];
    case {'1 Symbol'}
       TrainBlock = [1 1];
       DataBlock  = [2 162];
    case {'1/1 Symbols'}
       TrainBlock = [[ 1  1];[82  82]];
       DataBlock  = [[ 2 81];[83 162]];
    case {'2/2 Symbols'}
       TrainBlock = [[ 1  2];[82  83]];
       DataBlock  = [[ 3 81];[84 162]];
    case {'3/3 Symbols'}
       TrainBlock = [[ 1  3];[82  84]];
       DataBlock  = [[ 4 81];[85 162]];
    case {'3x1 Symbols'}
       TrainBlock = [[1  1];[55  55];[109 109]];
       DataBlock  = [[2 54];[56 108];[110 162]];
    case {'3x2 Symbols'}
       TrainBlock = [[1  2];[55  56];[109 110]];
       DataBlock  = [[3 54];[57 108];[111 162]];
    case {'4x1 Symbols'}
       TrainBlock = [[1  1];[42 42];[82  82];[122 122]];
       DataBlock =  [[2 41];[43 81];[83 121];[123 162]];
    case {'1 Symbol End'}
       DataBlock =  [  1 161];
       TrainBlock = [162 162];
    case {'1/1 Symbols End'}
       DataBlock  = [[ 1 80];[ 82 161]];
       TrainBlock = [[81 81];[162 162]];
    case {'2/2 Symbols End'}
       DataBlock  = [[ 1 79];[ 82 160]];
       TrainBlock = [[80 81];[161 162]];
    case {'3/3 Symbols End'}
       DataBlock  = [[ 1 78];[ 82 159]];
       TrainBlock = [[79 81];[160 162]];
    case {'3x1 Symbols End'}
       DataBlock  = [[ 1 53];[ 55 107];[109 161]];
       TrainBlock = [[54 54];[108 108];[162 162]];
    case {'3x2 Symbols End'}
       DataBlock  = [[ 1 52];[ 55 106];[109 160]];
       TrainBlock = [[53 54];[107 108];[161 162]];
    case {'4x1 Symbols End'}
       DataBlock =  [[ 1 40];[42 80];[ 82 120];[122 161]];
       TrainBlock = [[41 41];[81 81];[121 121];[162 162]];
    case {'8x1 Symbols'}
       TrainBlock = [[ 1  1];[22 22];[42 42];[62 62];[82  82];[102 102];[122 122];[142 142]];
       DataBlock  = [[ 2 21];[23 41];[43 61];[63 81];[83 101];[103 121];[123 141];[143 162]];
    case {'16x1 Symbols'}
       TrainBlock = [[ 1  1];[12 12];[22 22];[32 32];[42 42];[52 52];[62 62];[72 72];...
                     [82 82];[92  92];[102 102];[112 112];[122 122];[132 132];[142 142];[152 152]];
       DataBlock  = [[ 2 11];[13 21];[23 31];[33 41];[43 51];[53 61];[63 71];[73 81];...
                    [83 91];[93 101];[103 111];[113 121];[123 131];[133 141];[143 151];[153 162]];
    case {'14 Symbols'}
       TrainBlock = [1 14];
       DataBlock  = [15 162];
    case {'14/3/3/3/3 Symbols'}
       TrainBlock = [[ 1 14];[50 52];[86  88];[122 124];[158 160]];
       DataBlock  = [[15 49];[53 85];[89 121];[125 157];[161 162]];
   otherwise
       error('*** DATA_BLOCK.M : Unknown Training/Data Block Definition! ***');
    end;
elseif (nargin == 3)
    switch (DataBlockType)
    case {'Every L Symbols'}
        TrainBlock = [];
        DataBlock = [];
        for ii = 1:floor(length / L)
            TrainBlock = [TrainBlock; [(((ii - 1) * L) + 1) (((ii - 1) * L) + 1)]];
                       
            if (ii == floor(length / L))
                DataBlock = [DataBlock; [(((ii - 1) * L) + 2) length]];    
            else    

                DataBlock = [DataBlock; [(((ii - 1) * L) + 2) (ii * L)]];
            end  
                       
        end    
    case {'Every L Symbols End'}
        TrainBlock = [];
        DataBlock = [];
        for ii = 1:floor(length / L)
            TrainBlock = [TrainBlock; [(ii * L) (ii * L)]];
            if (ii == floor(length / L))
                if (mod(length, L) == 0)
                    DataBlock = [DataBlock; [(((ii - 1) * L) + 1) length-1]];    
                else    
                    DataBlock = [DataBlock; [(((ii - 1) * L) + 1) ((ii * L) - 1)]];
                    DataBlock = [DataBlock; [((ii * L) + 1) length]];
                end    
            else    
                DataBlock = [DataBlock; [(((ii - 1) * L) + 1) ((ii * L) - 1)]];
            end    
        end        
    case {'Every L Symbols Beginning End'}
        TrainBlock = [];
        DataBlock = [];
      
        jj = floor(162 / L);
        kk = floor(35 / jj);

        DataBlock = [1 kk - 1];
        
        for ii = 1:floor(162 / L)
            TrainBlock = [TrainBlock; [(((ii ) * kk) ) (((ii ) * kk) )]];
            if (ii == floor(162 / L))
                DataBlock = [DataBlock; [(((ii ) * kk) + 1) 161]];    
            else    
                DataBlock = [DataBlock; [(((ii ) * kk) + 1) ((ii + 1) * kk) - 1]];
            end    
        end

        TrainBlock = [TrainBlock; [162 162]];


    end;
else
   error('*** data_block.M : Inputs must be "Datablock type, Length of data block, length of signal ***');
end    
        
    
