function CR_qpsk = invdqpsk(CR_dqpsk, CS_ref)
% Converts DQPSK to QPSK
% CR_qpsk = invdqpsk(CR_dqpsk, CS_ref)

% The reference bit at the beginning.
if (nargin < 2)
   CS_ref = +1;
end;

PS_length = length(CR_dqpsk);

% CS_newRef = conj(CS_ref);
% for n = 1 : PS_length
%    CR_qpsk(n) = CS_newRef * CR_dqpsk(n);
%    CS_newRef = conj(CR_dqpsk(n));
% end;

% This is the d*(k - 1) in Stephen's paper.
CR_ref = conj([CS_ref CR_dqpsk(1:PS_length-1)]);
CR_qpsk = CR_ref .* CR_dqpsk;
