function RR_sqrtmrcos = sqrtmrcos(RS_duration, RS_dt, FS_rolloff, RS_period)
% RR_sqrtmrcos = sqrtbrcos2(RS_duration, RS_dt, FS_rolloff, RS_period)

RS_numPoint = ceil(RS_duration / RS_dt);
RS_df = 1 / RS_dt / RS_numPoint;
RS_begin = -(RS_numPoint/2)*RS_df;
RS_end = (RS_numPoint/2)*RS_df;
RS_freq = [RS_begin:RS_df:RS_end];
RR_sqrtmrcos = sqrt(mrcosf(RS_freq, FS_rolloff, RS_period))/RS_dt;
v = version;
if strcmp(v,'5.2.0.3084')
   RR_sqrtmrcos = real(fftshift(ifft(ifftshift(RR_sqrtmrcos))));
elseif strcmp(v,'5.0.0.4064')
   RR_sqrtmrcos = real(fftshift(ifft(ext_ifftshift(RR_sqrtmrcos))));
else
   RR_sqrtmrcos = real(fftshift(ifft(ifftshift(RR_sqrtmrcos))));
end;