function RR_sqrtsfrcos = sqrtsfrcos(RS_duration, RS_dt, FS_rolloff, RS_period, RS_shift)
% RR_sqrtsfrcos = sqrtrcos(RS_duration, RS_dt, FS_rolloff, RS_period)

RS_numPoint = ceil(RS_duration / RS_dt);
RS_df = 1 / RS_dt / RS_numPoint;
RS_begin = -(RS_numPoint/2)*RS_df;
RS_end = (RS_numPoint/2)*RS_df;
RS_freq = [RS_begin:RS_df:RS_end];
RR_sqrtsfrcos = sqrt(sfrcosf(RS_freq, FS_rolloff, RS_period, RS_shift))/RS_dt;
v = version;
if strcmp(v,'5.2.0.3084')
   RR_sqrtsfrcos = real(fftshift(ifft(ifftshift(RR_sqrtsfrcos))));
elseif strcmp(v,'5.0.0.4064')
   RR_sqrtsfrcos = real(fftshift(ifft(ext_ifftshift(RR_sqrtsfrcos))));
else
   RR_sqrtsfrcos = real(fftshift(ifft(ifftshift(RR_sqrtsfrcos))));
end;
